diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/bak2db.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/bak2db.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/bak2db.in	2013-09-16 12:54:44.439015292 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/bak2db.in	2013-09-16 12:58:25.527019898 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@nss_libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/db2bak.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/db2bak.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/db2bak.in	2013-09-16 12:54:44.447015221 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/db2bak.in	2013-09-16 12:58:25.535020258 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@nss_libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/db2index.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/db2index.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/db2index.in	2013-09-16 12:54:44.451015196 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/db2index.in	2013-09-16 12:58:25.539020279 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@nss_libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/db2ldif.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/db2ldif.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/db2ldif.in	2013-09-16 12:54:44.455015196 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/db2ldif.in	2013-09-16 12:58:25.543020275 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@nss_libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/dbverify.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/dbverify.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/dbverify.in	2013-09-16 12:54:44.459015215 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/dbverify.in	2013-09-16 12:58:25.551020235 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@nss_libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/dn2rdn.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/dn2rdn.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/dn2rdn.in	2013-09-16 12:54:44.463015220 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/dn2rdn.in	2013-09-16 12:58:25.555020215 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@nss_libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/ldif2db.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/ldif2db.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/ldif2db.in	2013-09-16 12:54:44.471015223 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/ldif2db.in	2013-09-16 12:58:25.559020205 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@nss_libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/ldif2ldap.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/ldif2ldap.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/ldif2ldap.in	2013-09-16 12:54:44.475015221 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/ldif2ldap.in	2013-09-16 12:58:25.567020214 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@ldapsdk_libdir@"
 libpath_add "@libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/monitor.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/monitor.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/monitor.in	2013-09-16 12:54:44.479015218 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/monitor.in	2013-09-16 12:58:25.571020216 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@ldapsdk_libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/restart-dirsrv.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/restart-dirsrv.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/restart-dirsrv.in	2013-09-16 12:54:44.487015217 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/restart-dirsrv.in	2013-09-16 12:58:25.579020217 +0200
@@ -7,7 +7,7 @@
 #       2: Server started successfully (was not running)
 #       3: Server could not be stopped
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 restart_instance() {
     SERV_ID=$1
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/restoreconfig.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/restoreconfig.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/restoreconfig.in	2013-09-16 12:54:44.491015218 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/restoreconfig.in	2013-09-16 12:58:25.583020216 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@nss_libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/saveconfig.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/saveconfig.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/saveconfig.in	2013-09-16 12:54:44.495015219 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/saveconfig.in	2013-09-16 12:58:25.587020214 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/start-dirsrv.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/start-dirsrv.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/start-dirsrv.in	2013-09-16 12:54:44.499015219 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/start-dirsrv.in	2013-09-16 12:58:25.591020213 +0200
@@ -6,7 +6,7 @@
 #       1: Server could not be started
 #       2: Server already running
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 # Starts a single instance
 start_instance() {
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/stop-dirsrv.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/stop-dirsrv.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/stop-dirsrv.in	2013-09-16 12:54:44.503015218 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/stop-dirsrv.in	2013-09-16 12:58:25.595020213 +0200
@@ -6,7 +6,7 @@
 #       1: Server could not be stopped
 #       2: Server was not running
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 stop_instance() {
     SERV_ID=$1
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/suffix2instance.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/suffix2instance.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/suffix2instance.in	2013-09-16 12:54:44.507015218 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/suffix2instance.in	2013-09-16 12:58:25.599020214 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/upgradedb.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/upgradedb.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/upgradedb.in	2013-09-16 12:54:44.535015219 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/upgradedb.in	2013-09-16 12:58:25.627020215 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@libdir@"
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/upgradednformat.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/upgradednformat.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/upgradednformat.in	2013-09-16 12:54:44.539015219 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/upgradednformat.in	2013-09-16 12:58:25.631020216 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 # upgradednformat -- upgrade DN format to the new style (RFC 4514)
 # Usgae: upgradednformat [-N] -n backend_instance -a db_instance_directory
diff -u 389-ds-base-1.3.1.8/ldap/admin/src/scripts/vlvindex.in 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/vlvindex.in
--- 389-ds-base-1.3.1.8/ldap/admin/src/scripts/vlvindex.in	2013-09-16 12:54:44.543015220 +0200
+++ 389-ds-base-1.3.1.8-local/ldap/admin/src/scripts/vlvindex.in	2013-09-16 12:58:25.639020215 +0200
@@ -1,6 +1,6 @@
 #!/bin/sh
 
-source @datadir@/@package_name@/data/DSSharedLib
+. @datadir@/@package_name@/data/DSSharedLib
 
 libpath_add "@libdir@/@package_name@/"
 libpath_add "@libdir@"